UIPackage
Menu

Framework

Change language

Boilerplate repo

Speed Dial

speed-dial ui
Boilerplate repo

Expanding floating action button that reveals a list of secondary action buttons. Supports click or hover triggers, four expansion directions (up/down/left/right), staggered entrance animation, a configurable main FAB icon, and close-on-action. Built on the fab and popover primitives.

Also available for Vue ->

Installation

$ npx shadcn@latest add https://uipkge.dev/r/react/speed-dial.json
Named registry: npx shadcn@latest add @uipkge-react/speed-dial Installs to: components/ui/speed-dial/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
actions SpeedDialAction[] required
icon

Main FAB icon.

LucideIcon optional
label

Accessible label for the main FAB.

string optional
direction Direction optional
trigger Trigger optional
closeOnAction

Close the dial after an action is triggered.

boolean optional
variant 'default' | 'secondary' | 'destructive' | 'outline' optional
position 'bottom-right' | 'bottom-left' | 'top-right' | 'top-left' | 'bottom-center' | 'inline' optional
absolute boolean optional
disabled boolean optional
className string optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SpeedDialAction
interface SpeedDialAction {
  icon: LucideIcon
  label: string
  handler?: () => void
  disabled?: boolean
  className?: string
}

Files installed (2)

  • components/ui/speed-dial/SpeedDial.tsx 5.7 kB
    'use client'
    
    import * as React from 'react'
    import type { LucideIcon } from 'lucide-react'
    import { Plus } from 'lucide-react'
    import { Popover, PopoverContent, PopoverTrigger } from '@/components/ui/popover'
    import { Fab } from '@/components/ui/fab'
    import { cn } from '@/lib/utils'
    
    export interface SpeedDialAction {
      icon: LucideIcon
      label: string
      handler?: () => void
      disabled?: boolean
      className?: string
    }
    
    type Direction = 'up' | 'down' | 'left' | 'right'
    type Trigger = 'click' | 'hover'
    
    export interface SpeedDialProps {
      actions: SpeedDialAction[]
      /** Main FAB icon. */
      icon?: LucideIcon
      /** Accessible label for the main FAB. */
      label?: string
      direction?: Direction
      trigger?: Trigger
      /** Close the dial after an action is triggered. */
      closeOnAction?: boolean
      variant?: 'default' | 'secondary' | 'destructive' | 'outline'
      position?: 'bottom-right' | 'bottom-left' | 'top-right' | 'top-left' | 'bottom-center' | 'inline'
      absolute?: boolean
      disabled?: boolean
      className?: string
    }
    
    const sideMap: Record<Direction, 'top' | 'bottom' | 'left' | 'right'> = {
      up: 'top',
      down: 'bottom',
      left: 'left',
      right: 'right',
    }
    
    const SpeedDial = React.forwardRef<HTMLButtonElement, SpeedDialProps>(
      (
        {
          actions,
          icon: Icon,
          label,
          direction = 'up',
          trigger = 'click',
          closeOnAction = true,
          variant = 'default',
          position = 'bottom-right',
          absolute = false,
          disabled = false,
          className,
        },
        ref,
      ) => {
        const [open, setOpen] = React.useState(false)
        const hoverTimerRef = React.useRef<ReturnType<typeof setTimeout> | null>(null)
    
        const clearHoverTimer = React.useCallback(() => {
          if (hoverTimerRef.current) {
            clearTimeout(hoverTimerRef.current)
            hoverTimerRef.current = null
          }
        }, [])
    
        const onTriggerEnter = React.useCallback(() => {
          if (disabled || trigger !== 'hover') return
          clearHoverTimer()
          setOpen(true)
        }, [disabled, trigger, clearHoverTimer])
    
        const onTriggerLeave = React.useCallback(() => {
          if (trigger !== 'hover') return
          clearHoverTimer()
          hoverTimerRef.current = setTimeout(() => setOpen(false), 150)
        }, [trigger, clearHoverTimer])
    
        const onContentEnter = React.useCallback(() => {
          if (trigger !== 'hover') return
          clearHoverTimer()
        }, [trigger, clearHoverTimer])
    
        const onContentLeave = React.useCallback(() => {
          if (trigger !== 'hover') return
          clearHoverTimer()
          hoverTimerRef.current = setTimeout(() => setOpen(false), 150)
        }, [trigger, clearHoverTimer])
    
        React.useEffect(() => clearHoverTimer, [clearHoverTimer])
    
        // Trigger is a wrapper div (asChild); Fab disabled alone does not block Popover.
        function handleOpenChange(next: boolean) {
          if (disabled) {
            setOpen(false)
            return
          }
          setOpen(next)
        }
    
        function runAction(action: SpeedDialAction) {
          if (action.disabled) return
          action.handler?.()
          if (closeOnAction) setOpen(false)
        }
    
        const side = sideMap[direction]
        const listClass =
          direction === 'up' || direction === 'down'
            ? 'flex flex-col items-center gap-3'
            : 'flex flex-row items-center gap-3'
    
        return (
          <Popover open={open} onOpenChange={handleOpenChange}>
            <PopoverTrigger asChild>
              <div
                data-uipkge=""
                data-slot="speed-dial"
                className={cn(className)}
                onMouseEnter={onTriggerEnter}
                onMouseLeave={onTriggerLeave}
              >
                <Fab
                  ref={ref}
                  variant={variant}
                  position={position}
                  absolute={absolute}
                  disabled={disabled}
                  aria-label={label || 'Quick actions'}
                  aria-expanded={open}
                  aria-haspopup="menu"
                  className={cn('transition-transform duration-200', open && 'rotate-45')}
                  onClick={trigger === 'hover' ? (e) => e.stopPropagation() : undefined}
                >
                  {Icon ? <Icon /> : <Plus />}
                </Fab>
              </div>
            </PopoverTrigger>
    
            <PopoverContent
              side={side}
              align="center"
              sideOffset={12}
              className={cn('w-auto border-0 bg-transparent p-0 shadow-none', trigger === 'hover' && 'pointer-events-auto')}
              onMouseEnter={onContentEnter}
              onMouseLeave={onContentLeave}
            >
              <div className={listClass}>
                {actions.map((action, i) => {
                  const ActionIcon = action.icon
                  return (
                    <button
                      key={i}
                      type="button"
                      data-slot="speed-dial-action"
                      disabled={action.disabled}
                      aria-label={action.label}
                      style={{ animationDelay: `${i * 40}ms` }}
                      className={cn(
                        "group/speed-dial-item bg-background text-foreground hover:bg-accent hover:text-accent-foreground motion-safe:animate-in motion-safe:fade-in-0 motion-safe:zoom-in-95 focus-visible:ring-ring/50 inline-flex size-12 items-center justify-center rounded-full border shadow-md transition-colors outline-none focus-visible:ring-[3px] disabled:pointer-events-none disabled:opacity-50 [&_svg]:pointer-events-none [&_svg]:shrink-0 [&_svg:not([class*='size-'])]:size-5",
                        action.className,
                      )}
                      onClick={() => runAction(action)}
                    >
                      <ActionIcon />
                      <span className="sr-only">{action.label}</span>
                    </button>
                  )
                })}
              </div>
            </PopoverContent>
          </Popover>
        )
      },
    )
    SpeedDial.displayName = 'SpeedDial'
    
    export { SpeedDial }
  • components/ui/speed-dial/index.ts 0.1 kB
    export { SpeedDial, type SpeedDialAction, type SpeedDialProps } from './SpeedDial'

Raw manifest: https://uipkge.dev/r/react/speed-dial.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Speed Dial

speed-dial ui
Boilerplate repo

Expanding floating action button that reveals a list of secondary action buttons. Supports click or hover triggers, four expansion directions (up/down/left/right), staggered entrance animation, a configurable main FAB icon, and close-on-action. Built on the fab and popover primitives.

Also available for React ->

Installation

$ npx shadcn-vue@latest add https://uipkge.dev/r/vue/speed-dial.json
Named registry: npx shadcn-vue@latest add @uipkge/speed-dial Installs to: app/components/ui/speed-dial/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
actions SpeedDialAction[] required
icon

Main FAB icon.

Component optional
label

Accessible label for the main FAB.

string optional
direction Direction 'up' optional
trigger Trigger 'click' optional
closeOnAction

Close the dial after an action is triggered.

boolean true optional
variant
'default''secondary''destructive''outline'
'default' optional
position
'bottom-right''bottom-left''top-right''top-left''bottom-center''inline'
'bottom-right' optional
absolute boolean false optional
disabled boolean optional
class HTMLAttributes['class'] optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SpeedDialAction
interface SpeedDialAction {
  icon: Component
  label: string
  handler?: () => void
  disabled?: boolean
  class?: HTMLAttributes['class']
}

npm dependencies

Includes

Files installed (2)

  • app/components/ui/speed-dial/SpeedDial.vue 4.7 kB
    <script setup lang="ts">
    import type { Component, HTMLAttributes } from 'vue'
    import { computed, ref } from 'vue'
    import { Popover, PopoverContent, PopoverTrigger } from '@/components/ui/popover'
    import { Fab } from '@/components/ui/fab'
    import { cn } from '@/lib/utils'
    import { Plus } from 'lucide-vue-next'
    
    export interface SpeedDialAction {
      icon: Component
      label: string
      handler?: () => void
      disabled?: boolean
      class?: HTMLAttributes['class']
    }
    
    type Direction = 'up' | 'down' | 'left' | 'right'
    type Trigger = 'click' | 'hover'
    
    interface Props {
      actions: SpeedDialAction[]
      /** Main FAB icon. */
      icon?: Component
      /** Accessible label for the main FAB. */
      label?: string
      direction?: Direction
      trigger?: Trigger
      /** Close the dial after an action is triggered. */
      closeOnAction?: boolean
      variant?: 'default' | 'secondary' | 'destructive' | 'outline'
      position?: 'bottom-right' | 'bottom-left' | 'top-right' | 'top-left' | 'bottom-center' | 'inline'
      absolute?: boolean
      disabled?: boolean
      class?: HTMLAttributes['class']
    }
    
    const props = withDefaults(defineProps<Props>(), {
      direction: 'up',
      trigger: 'click',
      closeOnAction: true,
      variant: 'default',
      position: 'bottom-right',
      absolute: false,
    })
    
    const open = ref(false)
    let hoverTimer: ReturnType<typeof setTimeout> | null = null
    
    function onTriggerEnter() {
      if (props.disabled || props.trigger !== 'hover') return
      if (hoverTimer) clearTimeout(hoverTimer)
      open.value = true
    }
    
    function onTriggerLeave() {
      if (props.trigger !== 'hover') return
      if (hoverTimer) clearTimeout(hoverTimer)
      hoverTimer = setTimeout(() => (open.value = false), 150)
    }
    
    function onContentEnter() {
      if (props.trigger !== 'hover') return
      if (hoverTimer) clearTimeout(hoverTimer)
    }
    
    function onContentLeave() {
      if (props.trigger !== 'hover') return
      if (hoverTimer) clearTimeout(hoverTimer)
      hoverTimer = setTimeout(() => (open.value = false), 150)
    }
    
    function onOpenChange(next: boolean) {
      // Trigger is a wrapper div (as-child); Fab disabled alone does not block Popover.
      if (props.disabled) {
        open.value = false
        return
      }
      open.value = next
    }
    
    function runAction(action: SpeedDialAction) {
      if (action.disabled) return
      action.handler?.()
      if (props.closeOnAction) open.value = false
    }
    
    const side = computed(() => {
      switch (props.direction) {
        case 'up':
          return 'top'
        case 'down':
          return 'bottom'
        case 'left':
          return 'left'
        case 'right':
          return 'right'
      }
    })
    
    const listClass = computed(() => {
      const base = 'flex items-center gap-3'
      return props.direction === 'up' || props.direction === 'down' ? `${base} flex-col` : `${base} flex-row`
    })
    </script>
    
    <template>
      <Popover :open="open" @update:open="onOpenChange">
        <PopoverTrigger as-child>
          <div
            data-uipkge
            data-slot="speed-dial"
            :class="cn(props.class)"
            @mouseenter="onTriggerEnter"
            @mouseleave="onTriggerLeave"
          >
            <Fab
              :variant="variant"
              :position="position"
              :absolute="absolute"
              :disabled="disabled"
              :aria-label="label || 'Quick actions'"
              :aria-expanded="open"
              aria-haspopup="menu"
              :class="cn('transition-transform duration-200', open && 'rotate-45')"
              @click="trigger === 'hover' ? $event.stopPropagation() : undefined"
            >
              <component :is="icon" v-if="icon" />
              <Plus v-else />
            </Fab>
          </div>
        </PopoverTrigger>
    
        <PopoverContent
          :side="side"
          align="center"
          :side-offset="12"
          :class="cn('w-auto border-0 bg-transparent p-0 shadow-none', trigger === 'hover' && 'pointer-events-auto')"
          @mouseenter="onContentEnter"
          @mouseleave="onContentLeave"
        >
          <div :class="listClass">
            <button
              v-for="(action, i) in actions"
              :key="i"
              type="button"
              data-slot="speed-dial-action"
              :disabled="action.disabled"
              :aria-label="action.label"
              :style="{ animationDelay: `${i * 40}ms` }"
              class="group/speed-dial-item bg-background text-foreground hover:bg-accent hover:text-accent-foreground motion-safe:animate-in motion-safe:fade-in-0 motion-safe:zoom-in-95 focus-visible:ring-ring/50 inline-flex size-12 items-center justify-center rounded-full border shadow-md transition-colors outline-none focus-visible:ring-[3px] disabled:pointer-events-none disabled:opacity-50 [&_svg]:pointer-events-none [&_svg]:shrink-0 [&_svg:not([class*='size-'])]:size-5"
              :class="action.class"
              @click="runAction(action)"
            >
              <component :is="action.icon" />
              <span class="sr-only">{{ action.label }}</span>
            </button>
          </div>
        </PopoverContent>
      </Popover>
    </template>
  • app/components/ui/speed-dial/index.ts 0.1 kB
    export { default as SpeedDial } from './SpeedDial.vue'
    export type { SpeedDialAction } from './SpeedDial.vue'

Raw manifest: https://uipkge.dev/r/vue/speed-dial.json